import arcpy
arcpy.env.workspace = "in_memory"
arcpy.env.overwriteOutput = True

# Načti vstupy jako seznam tabulek
tabulky = arcpy.GetParameterAsText(0).split(";")  # Rozdělení názvů tabulek podle středníku
tabulky_OP = arcpy.GetParameterAsText(2).split(";")

ulozeni_linie = arcpy.GetParameterAsText(1)
vzdalenost = arcpy.GetParameterAsText(3)
ulozeni_OP = arcpy.GetParameterAsText(4)
vystup = arcpy.GetParameterAsText(5)
obalka = arcpy.GetParameterAsText(6)

#Pro vrstvy s vícero obrazci
try:
    # Vytvoř prázdný seznam pro ukládání vrstev
    vrstvy = []
    # Pro každou vstupní tabulku
    for idx, tabulka in enumerate(tabulky):
        # Načíst data z tabulky do bodové vrstvy
        body = arcpy.management.XYTableToPoint(tabulka, f"vystup_body_{idx}", "X", "Y", "", arcpy.SpatialReference("S-JTSK_Krovak_East_North"))

        # Points to Line s možností uzavření - vytvoří dočasnou vrstvu v paměti
        linie = arcpy.management.PointsToLine(body, f"vystup_linie_{idx}", "", "", "CLOSE")

        # Přidání vrstvy do seznamu
        vrstvy.append(linie)

    # Sloučení všech vytvořených liniových vrstev do jedné vrstvy
    hranice = arcpy.management.Merge(vrstvy, "hranice")

    # Vytvoření liniové vrstvy
    #pro fyzickou vrstvu
    try:
        # Sloučení všech vytvořených liniových vrstev do jedné vrstvy
        hranice = arcpy.management.Merge(vrstvy, ulozeni_linie)
        polygon = arcpy.management.FeatureToPolygon(hranice, "uzemi")
    #pouze pro paměť
    except:
        hranice = arcpy.management.Merge(vrstvy, "hranice")
        polygon = arcpy.management.FeatureToPolygon(hranice, "uzemi")

    ##když je tabulka jen 1, selže indexovani... takže půjde na except

#pro území s 1 obrazcem
except:    
    # Načtení dat z tabulky do bodové vrstvy
    body = arcpy.management.XYTableToPoint(tabulky[0],"output_point_fc", "X", "Y", "", arcpy.SpatialReference("S-JTSK_Krovak_East_North"))

    # 2. Points to Line s možností uzavření - vytvoří dočasnou vrstvu v paměti
    linie = arcpy.management.PointsToLine(body, "output_line_fc", "", "", "CLOSE")

    #převedení na liniovou vrstvu
    try:
        #Points to Line s možností uzavření - vytvoří se vrstva
        linie = arcpy.management.PointsToLine(body, ulozeni_linie, "", "", "CLOSE")
        polygon = arcpy.management.FeatureToPolygon(linie,"uzemi")
    except:
        #Points to Line s možností uzavření - vytvoří dočasnou vrstvu v paměti
        linie = arcpy.management.PointsToLine(body, "output_line_fc", "", "", "CLOSE")
        polygon = arcpy.management.FeatureToPolygon(linie,"uzemi")

############následuje OCHRANNÉ PÁSMO
#pokud nejsou určeny obrazce, vytvoříme 50 m pásmo (ze zákona)
try:
    try:
        OP = arcpy.analysis.Buffer(polygon, "ulozeni_OP", vzdalenost, "OUTSIDE_ONLY","","ALL")
        vrstva_OP = arcpy.management.FeatureToLine(OP, ulozeni_OP)
    except:
        OP = arcpy.analysis.Buffer(polygon, "ulozeni_OP", vzdalenost, "OUTSIDE_ONLY","","ALL")


    cele_dohromady = arcpy.analysis.Union([polygon,OP], vystup)

#pokud jsou obrazce, stejný postup jako u samotného území
except:        
    try:
        # Vytvoř prázdný seznam pro ukládání vrstev
        vrstvy_OP = []
        # Pro každou vstupní tabulku
        for idx, tabulka_OP in enumerate(tabulky_OP):
            # Načtení dat z tabulky do bodové vrstvy
            body_OP = arcpy.management.XYTableToPoint(tabulka_OP, f"output_point_OP_{idx}", "X", "Y", "", arcpy.SpatialReference("S-JTSK_Krovak_East_North"))

            # Points to Line s možností uzavření - vytvoří dočasnou vrstvu v paměti
            linie_OP = arcpy.management.PointsToLine(body_OP, f"output_line_OP_{idx}", "", "", "CLOSE")

            # Přidání vrstvy do seznamu
            vrstvy_OP.append(linie_OP)

        # Vytvoření liniové vrstvy
        #pro fyzickou vrstvu
        try:
            # Sloučení všech vytvořených liniových vrstev do jedné vrstvy
           hranice_OP = arcpy.management.Merge(vrstvy_OP, ulozeni_OP)
           polygon_OP = arcpy.management.FeatureToPolygon(hranice_OP, "uzemi_OP")
        #pouze pro paměť
        except:
            # Sloučení všech vytvořených liniových vrstev do jedné vrstvy
            hranice_OP = arcpy.management.Merge(vrstvy_OP, "hranice_OP")
            polygon_OP = arcpy.management.FeatureToPolygon(hranice_OP, "uzemi_OP")

        ##když je tabulka jen 1, selže indexování... takže půjde na except

    #pro OP s 1 obrazcem
    except:    
        # Načti data z tabulky do bodové vrstvy
        body_OP = arcpy.management.XYTableToPoint(tabulky_OP[0],"output_point_OP", "X", "Y", "", arcpy.SpatialReference("S-JTSK_Krovak_East_North"))

        # Points to Line s možností uzavření - vytvoří dočasnou vrstvu v paměti
        linie_OP = arcpy.management.PointsToLine(body_OP, "output_line_OP", "", "", "CLOSE")

        # převedení na liniovou vrstvu
        try:
            linie_OP = arcpy.management.PointsToLine(body_OP, ulozeni_OP, "", "", "CLOSE")
            polygon_OP = arcpy.management.FeatureToPolygon(linie_OP,"uzemi_OP")
        # jen pro paměť
        except:
            linie_OP = arcpy.management.PointsToLine(body_OP, "output_line_OP", "", "", "CLOSE")
            polygon_OP = arcpy.management.FeatureToPolygon(linie_OP,"uzemi_OP")

    #sjednocení všech vstupů
    cele_dohromady = arcpy.analysis.Union([polygon, polygon_OP], vystup)

# Nové pole pro rozlohu a výpočet
arcpy.AddField_management(cele_dohromady, "rozloha", "DOUBLE")
arcpy.CalculateField_management(cele_dohromady, "rozloha", '!shape.area@hectares!','PYTHON3')

#####OBÁLKA######

#nejmenší možný obdélník kolem všech polygonů

cela_obalka = arcpy.management.MinimumBoundingGeometry(cele_dohromady,obalka, "ENVELOPE", "ALL")

#výpočet šířky a výšky obálky
arcpy.AddField_management(cela_obalka, "sirka", "DOUBLE")
arcpy.AddField_management(cela_obalka, "vyska", "DOUBLE")
arcpy.CalculateField_management(cela_obalka, "sirka","!shape.extent.width!")
arcpy.CalculateField_management(cela_obalka, "vyska","!shape.extent.height!")

##Orientace A4:
#vytvoření proměnné pro porovnání (pomocí řetězce """, aby se zachovalo formátování)
porovnani = """
def check(sirka, vyska):
    if (sirka > vyska):
        return "Na šířku"
    else:
        return "Na výšku" """
arcpy.AddField_management(cela_obalka, "orientace_A4", "TEXT")
arcpy.CalculateField_management(cela_obalka, "orientace_A4", "check(!sirka!,!vyska!)",
                                "PYTHON3", porovnani)

##výpočet měřítka na základě rozměrů obálky a určení minimální velikosti na A4 rovno 18 cm
meritko = """
def check(orientace_A4, sirka, vyska):
    if (orientace_A4 == "Na šířku"):
        return sirka*100/18
    else:
        return vyska*100/18 """

arcpy.AddField_management(cela_obalka, "vypocet_meritka", "DOUBLE")
arcpy.CalculateField_management(cela_obalka, "vypocet_meritka", "check(!orientace_A4!,!sirka!,!vyska!)","PYTHON3", meritko)

